/*
 * Globally accessible information from xgraph
 */

#ifndef _TKXGRAPH_H_
#define _TKXGRAPH_H_

#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include "tcl.h"
#include "tk.h"
#include "xgout.h"
#include "st.h"

#ifndef _XLIB_H_ /* win32 sucks */
typedef struct {
    short x1, y1, x2, y2;
} XSegment;
#endif
typedef unsigned long Pixel;

#define MAXKEYS		50
#define MAXATTR 	8
#define MAXSETS		64
#define MAXBUFSIZE 	120
#define MAXLS		50

#define STRDUP(xx) \
  (strcpy((char *)malloc((unsigned) (strlen(xx)+1)), (xx)))

/* Globally accessible values */
extern int tkxg_depth;			/* Depth of screen         */

/*
 * a tkconfig-like value to indicate the options with MAXSETS parts like
 * seriescolor which require a series number and a value to work
 */
#define XG_CONFIG_MANY 200

/* the following struct needs to become a Tk_ConfigSpec 
 * (and so leave this header) under any conversion of tkxgraph to a canvas
 * widget.
 * Not all parseable options are included in this table, instead only those
 * that should be used in the future. All the deprecated xgraph switches
 * are left out.
 */
typedef struct xg_configspec {
    int type;                   /* Type of option, such as TK_CONFIG_COLOR;
                                 * see definitions tk.h.  Last option in
                                 * table must have type TK_CONFIG_END. */
    char *argvName;             /* tk-like switch used to specify option.
                                 * NULL means this spec is part of a group. */
    char *dbName;               /* Name for option in parameter table */
    char *dbClass;              /* Class for option in database. */
    char *dbInit;               /* Default for option parameters */
} xg_configspec;

/* Initializes tk device , xgX.c   */
extern void set_tk
_ANSI_ARGS_((xgOut *, Tcl_Interp *, st_table *));

/* updates tk device  , xgX.c  */
extern void reset_tk
_ANSI_ARGS_((xgOut *,Tcl_Interp *,st_table *));


#endif /* _XGRAPH_H_ */
